#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

void initialise(void) {

	DDRC = 0x00;
	PORTC = 0xFF;

	DDRD = 0xFF;
	PORTD = 0x00;

	TCCR1A = _BV(COM1A1) | _BV(COM1B1) | _BV(WGM11) | _BV(WGM10);
	TCCR1B = _BV(WGM13) | _BV(CS12) | _BV(CS10);

}

void follow_line(void) {

    while (1) {

		int value = 0;
		int i = 0;
		for (i = 0; i < 8; i++)
			value |= (((1 << i) & PINC) >> i) << (7 - i);

		cli();

		OCR1AL = 200;
		OCR1BL = 200;

		sei();

		if (PINC - value >= (1 << 4))
			PORTD = _BV(PD3);
		else if (value - PINC >= (1 << 4))
			PORTD = _BV(PD6);
		else
			PORTD = _BV(PD6) | _BV(PD3);

		_delay_ms(25);

    }

}

int main(void) {

	initialise();

	follow_line();

	return 0;

}